---
title: RTCIceCandidate.address
slug: Web/API/RTCIceCandidate/address
tags:
  - API
  - Address
  - Candidate
  - ICE
  - IP
  - Networking
  - Property
  - RTCIceCandidate
  - Read-only
  - Reference
  - SDP
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("RTCIceCandidate")}}</strong> interface's read-only <strong><code>address</code></strong> property is a string providing the address of the device which is the source of the candidate.</span> <code>address</code> is <code>null</code> by default if not otherwise specified.</p>

<p>The <code>address</code> field's value is set when the {{domxref("RTCIceCandidate.RTCIceCandidate", "RTCIceCandidate()")}} constructor is used. You can't specify the <code>address</code> in the options object, but the address is automatically extracted from the {{domxref("RTCIceCandidateInit.candidate", "candidate")}} a-line, if it's formatted properly.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>address</em> = <em>RTCIceCandidate</em>.address;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} providing the IP address from which the candidate comes.</p>

<div class="note">
<p><strong>Note:</strong> If <code>port</code> is <code>null</code> — and <code>port</code> is supported by the {{Glossary("user agent")}} — passing the candidate to {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} will fail, throwing an <code>OperationError</code> exception.</p>
</div>

<h2 id="Security_notes">Security notes</h2>

<p>It's important to note here that although WebRTC does not require the two peers on an {{domxref("RTCPeerConnection")}} to know one another's true IP addresses, the <code>address</code> property on <code>RTCIceCandidate</code> <em>can</em> expose more information about the source of the remote peer than the user expects. The IP address can be used to derive information about the remote device's location, network topology, and so forth. It can also be used for fingerprinting purposes.</p>

<p>The candidate IP addresses are <em>always</em> exposed to the application through <code>address</code>, and unsavory applications can in turn potentially reveal the address to the user. This can occur without the remote peer's consent.</p>

<p>Applications being built with user privacy and security in mind can choose to limit the permitted candidates to relay candidates only. Doing so prevents the remote user's address from being exposed, but reduces the pool of available candidates to choose from. To do this, configure the ICE agent's ICE transport policy using {{domxref("RTCConfiguration")}}, like this:</p>

<pre class="brush: js">var rtcConfig = {
  iceServers: [
    {
      urls: "turn:myturn.server.ip",
      username: "username",
      credential: "password"
    }
  ],
  iceTransportPolicy: "relay"
}
</pre>

<p>By setting {{domxref("RTCConfiguration.iceTransportPolicy")}} to <code>"relay"</code>, any host candidates (candidates where the IP address is the peer's own IP address) are left out of the pool of candidates, as are any other candidates which aren't relay candidates.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Consider this {{Glossary("SDP")}} attribute line (a-line) which describes an ICE candidate:</p>

<pre>a=candidate:4234997325 1 udp 2043278322 192.168.0.56 44323 typ host</pre>

<p>The fifth field, <code>"192.168.0.56"</code> is the IP address in this candidate's a-line string.</p>

<h2 id="Example">Example</h2>

<p>This code snippet uses the value of <code>address</code> to implement an IP address based ban feature.</p>

<pre class="brush: js">if (ipBanList.includes(candidate.address)) {
  rejectCandidate(candidate);
} else {
  acceptCandidate(candidate);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicecandidate-address', 'RTCIceCandidate: address')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate.address")}}</p>
</div>
